#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<richedit.h>
#include	<ctime>
#include	<cstdio>
#include	<iostream>
#include	<fstream>
#include	<vector>
using namespace std;
#include	"common.h"
#include	"SvRingBuf.h"
#include	"SvType.h"
#include	"SvVariable.h"
#include	"SvDefine.h"
#include	"GateIO.h"
#include	"SvClass.h"
#include	"SvFunction.h"
#include	"SvRsvWord.h"
#include	"SvIncClass.h"
#include	"EpConfig.h"
#include	"SvData.h"
#include	"SvUsingName.h"
#include	"SvStructPushPop.h"
#include	"MainPRG.h"
#include	"SvFileStack.h"
#include	"SvFileNo.h"
#include	"SvFileRead.h"
#include	"SvFileTree.h"



//----------------------------- ϐ ---------------------------
extern	FileStInfo	Fdata;							// I[vt@C̃f[^
extern	Option		EpOp;							// IvV
//--------
double	jikan;
EpConfig	ConfigObj;							// Eptree̐ݒۑIuWFNg
SvDefine	*DefObj   = NULL;						// defineeۑIuWFNg
SvFunction	*FuncObj  = NULL;						// ֐o^pIuWFNg
SvUsingName	*NamaeObj = NULL;						// OԂ̖̂ۑIuWFNg
SvClass		*ClassObj = NULL;						// NXi[IuWFNg
SvVariable	*VariableObj = NULL;						// ϐi[IuWFNg
SvType		*TypeObj  = NULL;						// ^i[IuWFNg
SvFileNo	*FileNoObj= NULL;						// t@C̕ۑpIuWFNg
SvFileStack	*FileStackObj = NULL;						// ݏ̃t@Ci[IuWFNg
SvFileRead	*ReadFileObj = NULL;
SvFileTree	*FileTreeObj = NULL;						// t@Cc[i[IuWFNg

//---------------------- ֐vg^Cv --------------------
void	aplmain();
void	aplmain(MainPRG *);
void	aplmainSub(MainPRG *, ifstream *, int);
void	EP_ConfigUp(MainPRG *,int);


//--------------------------------------------------------------------------
// t@C̃I[v
//--------------------------------------------------------------------------
void EpOutFileOpen(char *OrgFileName, ofstream *OpenFile)
{
	std::string FilePass;

	FilePass  = EpOp.strResultOutPath;
	FilePass += OrgFileName;

	OpenFile->open(FilePass.c_str(), ios_base::trunc);			// t@CJ(VK쐬)
}

//--------------------------------------------------------------------------
// t@C̃I[v
//--------------------------------------------------------------------------
void EpOutFileOpenAdd(char *OrgFileName, ofstream *OpenFile)
{
	std::string FilePass;

	FilePass  = EpOp.strResultOutPath;
	FilePass += OrgFileName;

	OpenFile->open(FilePass.c_str(), ios_base::app);				// t@CJ(ǋL)
}


//--------------------------------------------------------------------------
// AvP[VTop
//--------------------------------------------------------------------------
void EpAplTop()
{
extern	void	ReadEP_Config();						// Eptree̐ݒt@C̓ǂݍ
extern	void	CheckOutDir();

	CoInitialize(NULL);							// com̏

	DefObj      = new SvDefine();
	FuncObj     = new SvFunction();
	NamaeObj    = new SvUsingName();
	ClassObj    = new SvClass();
	VariableObj = new SvVariable();
	TypeObj     = new SvType();
	FileNoObj   = new SvFileNo();						// t@C̕ۑpIuWFNg
	FileStackObj= new SvFileStack();
	ReadFileObj = new SvFileRead();
	FileTreeObj = new SvFileTree();

	CheckOutDir();								// fBNg`FbN(쒆̃fBNg폜ɑΉ)

	//---------------t@CI[v---------------------------
	ofstream Elog;								// G[o͗pt@C
	EpOutFileOpen("EpTreeErrLog.txt", &Elog);
	cerr.rdbuf(Elog.rdbuf());
	//---------------s---------------------------
	ReadEP_Config();							// Eptree̐ݒt@C̓ǂݍ
	if( EpOp.PrintReserv )
		ConfigObj.RsvObj.Print();					// \̊mF
	aplmain();								// AvC
	ConfigObj.Init();							// ݒt@C̃NA
	//---------------t@CN[Y---------------------------
	Elog.close();								// G[O

	CoUninitialize();							//COM

	cerr.rdbuf(NULL);

	delete DefObj;
	delete FuncObj;
	delete FileNoObj;
	delete NamaeObj;
	delete ClassObj;
	delete VariableObj;
	delete TypeObj;
	delete FileStackObj;
	delete ReadFileObj;
	delete FileTreeObj;
	DefObj   = NULL;
	FuncObj  = NULL;
	FileNoObj= NULL;
	NamaeObj = NULL;
	ClassObj = NULL;
	VariableObj = NULL;
	TypeObj  = NULL;
	FileStackObj = NULL;
	ReadFileObj = NULL;
	FileTreeObj = NULL;
}


//--------------------------------------------------------------------------
// t@CǂݍޏԂݒ肷
//
// ̊֐̖߂lnewɂmۂ̈Ȃ̂Ŏgp
// Kdelete邱ƁB
//--------------------------------------------------------------------------
int *FileOrder()
{
	int *FileReadOrder = new int[Fdata.vecFileData.size()];
	int SetCnt = 0;
	int cnt;

	memset(FileReadOrder, '\0', sizeof(int)*Fdata.vecFileData.size());

	for(cnt=0;cnt<(int)Fdata.vecFileData.size();cnt++){
		char *p = strrchr((char *)Fdata.vecFileData[cnt].strSrcFName.c_str(), '.');
		if(p == NULL){
			break;
		}
		if( !stricmp(p, ".bas") ){
			FileReadOrder[SetCnt] = cnt;
			Fdata.vecFileData[cnt].tmp = 1;
			SetCnt++;
		}
	}
	for(cnt=0;cnt<(int)Fdata.vecFileData.size();cnt++){
		if( Fdata.vecFileData[cnt].tmp ){
			continue;
		}
		FileReadOrder[SetCnt] = cnt;
		SetCnt++;
	}

	return FileReadOrder;
}


//--------------------------------------------------------------------------
// AvP[VC
//--------------------------------------------------------------------------
void aplmain()
{
extern	HWND	Err_Edit;							// G[o̓EChE
extern	int	Thread_flg;
	int	*FileReadOrder = FileOrder();

	clock_t StartTime = clock();

	MainPRG   *Mobj = new MainPRG(1);					// O[oϐL
	ifstream  myfile;

	if( EpOp.OrgHeaderStat != HEADER_NORMAL ){				// wb_[𖈉ǂݍސݒłȂ
		EP_ConfigUp(Mobj, -1);
	}else{
		EpOp.ReadHeaderStat = EpOp.OrgHeaderStat;
	}

	for(int a=0;a<(int)Fdata.vecFileData.size();a++ ){			// \[Xt@CSĊJ
		int  FileNo = FileReadOrder[a];
		std::string strFullName = Fdata.vecFileData[FileNo].strPathOnly;
		std::string strShortName = Fdata.vecFileData[FileNo].strSrcFName;

		if(strShortName.length() == 0)					// t@CZbgĂȂ
			break;

		strFullName += strShortName;

		myfile.clear();							// G[rbgNA
		myfile.open(strFullName.c_str(),ios_base::binary|ios_base::in);
		if(myfile.fail()){
			cerr << " Can't open [" << strShortName.c_str() << "]" << endl;
			continue;
		}

		if( Thread_flg ){						// R\[NłȂ
			char str_buf[300];
			sprintf(str_buf, "(%4d/%4d) %s\n", a+1, Fdata.vecFileData.size(),
					(char *)strShortName.c_str());
			SendMessage(Err_Edit, WM_SETTEXT, SF_TEXT, (LPARAM)str_buf);
		}
		cerr << strShortName.c_str() << "" << endl;		//

		Mobj->SetFileName(strFullName);					// t@C̕ۑ

		if( EpOp.OrgHeaderStat == HEADER_NORMAL ){			// wb_[𖈉ǂݍސݒȂ
			// VB,Delphiexternwb_[ߌ^Ȃ
			// 悤ɂĂB̂ߌ^͍ŏ1񂾂荞܂ȂB
			if(a==0
			|| (Fdata.vecFileData[FileNo].SrcBit & (MASK_BIT_VB|MASK_BIT_DELPHI)) == 0){
				EP_ConfigUp(Mobj, a);
			}
		}

		aplmainSub(Mobj, &myfile, FileNo);				// ͎s

		Mobj->Init();							// s
		FileStackObj->DeleteFile();					// X^bNt@C폜
	}

	// \[Xɒ`Ă֐̐擾(Stepo͕\)
	for(int b=0;b<(int)Fdata.vecFileData.size();b++ ){			// \[Xt@CSĊJ
		std::string strSrcFNameX = Fdata.vecFileData[b].strSrcFName;	// t@C擾
		if(strSrcFNameX.length() == 0)					// t@CZbgĂȂ
			break;
		if( EpOp.Tree_tg ){						// ^O`ŕ\Ȃ
			strSrcFNameX.insert(0, Fdata.vecFileData[b].strPathOnly); // pXRs[
		}
		Fdata.vecFileData[b].Step.SrcFCnt = FuncObj->MakeSrcFCnt(strSrcFNameX);	// t@CɊ܂܂֐̐Zbg
	}

	Mobj->OutPut();								// ʂo

	delete FileReadOrder;
	delete Mobj;

	if( EpOp.Time ){
		time_t FinishTime = clock();
		jikan = (double)( FinishTime - StartTime ) / CLOCKS_PER_SEC;
		cerr << "Ԃ " << jikan << " błB" << endl;
	}
}


//--------------------------------------------------------------------------
// I[o[[h
// ĉA#include}\œǂݍ
//--------------------------------------------------------------------------
void aplmain(MainPRG *moto)
{
	char *IncFname = moto->IoObj.GetIncludeFileName();
	std::string strlongName = IncFname;
	int  longNameID = 0;
	ifstream  myfile;


	std::string strPath = FileStackObj->GetPath();				// ݁A͒̃\[X or wb_[ĂpX
	if( strPath.length() ){
		if( ! strchr(IncFname, ':') ){					// includet@C̃pX΃pXłȂ
			strlongName.insert(0, strPath);				// pXǉ
		}
	}

	if( ReadFileObj->Set((char *)strlongName.c_str(), IncFname) ){		// ǂݍރt@C̕ۑƍēǂݍ݃`FbN
		return;
	}

	myfile.open(strlongName.c_str(), ios_base::binary|ios_base::in);
	if(myfile.fail()){
		int aa;
		ReadFileObj->SetNG(strlongName, IncFname);			// JȂt@Co^
		if( strchr(IncFname, ':') || strchr(IncFname, '\\') || 
		    EpOp.vecIncludePath.size() == 0){
			cerr << "  Can't open [" << IncFname << "]" << endl;
			ReadFileObj->SetNG(strlongName, IncFname);		// JȂt@Co^
			FileStackObj->ReadNG_Check(IncFname);			// ÂNXǂݍł邩`FbN
			return;
		}
		// ̓fBNgŌȂΕWCN[h
		for(aa=0;aa<(int)EpOp.vecIncludePath.size();aa++){
			std::string strLName;
			strLName  = EpOp.vecIncludePath[aa];
			strLName += "\\";
			strLName += IncFname;
			myfile.clear();						// G[rbgNA
			myfile.open(strLName.c_str(), ios_base::binary|ios_base::in);
			if(myfile.fail()){
				ReadFileObj->SetNG(strLName, IncFname);		// JȂt@Co^
				continue;
			}
			break;
		}
		if(aa == (int)EpOp.vecIncludePath.size()){
			cerr << "  Can't open [" << IncFname << "]" << endl;
			ReadFileObj->SetNG(strlongName, IncFname);		// JȂt@Co^
			FileStackObj->ReadNG_Check(IncFname);				// ÂNXǂݍł邩`FbN
			return;
		}
	}

	MainPRG   *Hasei;

	Hasei = new MainPRG(0);							// IuWFNg̐

	cerr << "  " << IncFname << "" << endl ;			//
	Hasei->SetFileName(strlongName);					// t@C̕ۑ


	aplmainSub(Hasei,&myfile, -1);						// ͎s

	delete Hasei;
	FileStackObj->DeleteFile();						// X^bNt@C폜
}


//--------------------------------------------------------------------------
// C̋ʏ
//--------------------------------------------------------------------------
void aplmainSub(MainPRG *Mapl, ifstream *myfile, int FdataNo)
{
	char	setbuf[READ_MAX];
	int	Endflag = 0;

	while( ! Endflag ){							// t@C[܂œǂݍ
		memset(setbuf,'\0',sizeof(setbuf));
		myfile->read(setbuf,READ_MAX-2);
		char *tmp = Mapl->IoObj.SetStrCode(setbuf);			// R[hZbg(ŏ1̂)
		Endflag = myfile->eof();
		while(1){
			int result = Mapl->IoObj.read_Word(&tmp, Endflag);	// P̓ǂݍ
			if(result == READ_NEXT){				// P쐬̏ꍇ
				break;
			}else if(result == READ_SKIP){
				continue;
			}
			Mapl->AnalysisWord();					// P𕪐
			if( Mapl->IoObj.IncludeFileOn() ){			// #include
				if( EpOp.ReadHeaderStat != HEADER_NO ){
					aplmain( Mapl );			// ĉA
				}else{
					char *FileName = Mapl->IoObj.GetIncludeFileName();
					ReadFileObj->Set(FileName, FileName);
				}
				Mapl->IoObj.IncludeFileClear();			// #includet@C̏
			}
			if(result == READ_END){					// t@C̏I[܂ŏꍇ
				break;
			}
		}
	}

	Mapl->FileEndCheck();							// t@CIɍs`FbN (Ō̍s̃XebvvsĂ)
	myfile->close();

	if( FdataNo != -1 ){							// IuWFNgȂ(\[XȂ)
		// f[^ۂƃRs[
		Fdata.vecFileData[FdataNo].Step = Mapl->IoObj.LocalStep;
	}

}


//--------------------------------------------------------------------------
// Eptreeݒ.datɋLqꂽA^ARpCIvV
// NXAgݍ݃IuWFNgȂǂ擾
//--------------------------------------------------------------------------
void EP_ConfigUp(MainPRG *Mobj, int ReadFileNo)
{
extern	int MyFunc_GetSrcKind(char *);
	int cc;
	int tmp_max;
	int ret;

	//------------ ^{̂ɓn --------------------------------------
	// IuWFNg܂邲ƃRs[
	TypeObj->CopyVector( ConfigObj.TypeObj.GetVector() );

	TypeObj->ConfigFlgOnOff(1);
	// 荞݊֐̓o^L[[h
	Mobj->IoObj.SetInterruptKeyWord( ConfigObj.IoObj.GetInterruptKeyWord() );
	TypeObj->ConfigFlgOnOff(0);

	// #defineeۂƃRs[
	DefObj->CopyVector(ConfigObj.RestoreDefData());

	//----- C++ or Javaǂ`FbN -----------------------------------
	EpOp.ReadHeaderStat = EpOp.OrgHeaderStat;
	if( ReadFileNo == -1 ){							// wb_[𖈉ǂݍސݒɂȂĂȂ
		for(cc=0;cc<(int)Fdata.vecFileData.size();cc++){		// \[Xt@C̎ނ𒲂ׂ
			char *fname = (char *)Fdata.vecFileData[cc].strSrcFName.c_str();
			if(*fname == '\0'){
				return;
			}
			ret = MyFunc_GetSrcKind(fname);				// ̎ނ擾
			if(ret == 1 || ret == 2){				// cpp,java\[XȂ
				break;
			}
		}
		if(cc == Fdata.vecFileData.size()){
			return;
		}
	}else{									// ǂݍޏꍇ̓\[Xt@CC++\[X߂
		char *fname = (char *)Fdata.vecFileData[ReadFileNo].strSrcFName.c_str();
		if(*fname == '\0'){
			return;
		}
		ret = MyFunc_GetSrcKind(fname);					// ̎ނ擾
		if(ret != 1 && ret != 2){					// cpp,java\[XłȂꍇ
			return;
		}
	}
	if( EpOp.ReadHeaderStat == HEADER_NO )					// wb_[t@C͕Kǂݍ
		EpOp.ReadHeaderStat = HEADER_ONE;

	//--------- NX{̂ɓn ----------------------------------------
	tmp_max = ConfigObj.IncObj.GetMax();
	for(cc=0;cc<tmp_max;cc++){						// NX̎擾
		int lang;
		char *clname = ConfigObj.IncObj.Get(cc, &lang);
		if( clname ){
			FileStackObj->SetSrcLang(lang);
			std::string strCL = clname;
			ClassObj->Class_Set(strCL, 0);
		}else{
			break;
		}
	}
	TypeObj->ConfigFlgOnOff(1);						// ^gpƔFȂ悤ɂ邽
	tmp_max = ConfigObj.IncObj.GetObjMax();
	for(cc=0;cc<tmp_max;cc++){						// IuWFNg̎擾
		char *clname = ConfigObj.IncObj.GetObjData(0, cc);
		if(*clname == '\0'){
			break;
		}else{
			FileStackObj->SetSrcLang((int)ConfigObj.IncObj.GetObjData(2, cc));
			VariableObj->SetLocal(clname,
				ConfigObj.IncObj.GetObjData(1, cc), 0, 0, NULL, NULL);
		}
	}
	TypeObj->ConfigFlgOnOff(0);						// ^gpƔFȂ悤ɂ邽
	//---------------------------------------------------------------------
}


//--------------------------------------------------------------------------
// Eptree̐ݒt@C̓ǂݍ
// \ANX`A^ ̎擾
//--------------------------------------------------------------------------
void ReadEP_Config()
{
extern	char Exe_Path[260];							// Eptree.exẽpX
extern	int ObjTypeAddCheck_C(char *pStr);
extern	int MyFunc_GetSrcKind(char *);
extern	int MyFunc_SrcLangToBit(int);
	ifstream myfile;
	char SrcName[260];

	strcpy(SrcName, Exe_Path);
	strcat(SrcName, "Eptreeݒ.dat");					// `t@C

	DefObj->Init();

	int langMask = 0;
	for(int cnt=0;cnt<(int)Fdata.vecFileData.size();cnt++){
		char *p = strrchr((char *)Fdata.vecFileData[cnt].strSrcFName.c_str(), '.');
		if(p == NULL){
			break;
		}
		langMask |= MyFunc_SrcLangToBit( MyFunc_GetSrcKind(p) );
	}
	if(langMask & MASK_BIT_CPP){
		langMask |= MASK_BIT_CPP_OLD;
	}
	ConfigObj.SetMaskLang(langMask);					// Cn͑啶ʂAVBn͋ʂȂ̂œɂ͓łȂ
	if(langMask & (MASK_BIT_VB|MASK_BIT_DELPHI)){
		// \Ȃǂ̊i[stricmpɂ
		MyFunc_strcmp = (volatile int(*)(const char*, const char *))stricmp;
	}

	ConfigObj.IoObj.SetEpConfModeOn();					// Epconfig.datǂݍނƂɎgpʏtOON

	myfile.open(SrcName,ios_base::binary|ios_base::in);
	if(myfile.fail()){
		ConfigObj.ConfigFileNotExist(SrcName);				// Eptreeݒ.datt@C݂Ȃꍇ̏
		return;
	}
	ObjTypeAddCheck = ObjTypeAddCheck_C;					// ֐|C^ݒ

	char setbuf[READ_MAX];
	int  Endflag = 0;
	while( ! Endflag ){							// t@C[܂œǂݍ
		memset(setbuf,'\0',sizeof(setbuf));
		myfile.read(setbuf,READ_MAX-2);
		char *tmp = ConfigObj.IoObj.SetStrCode(setbuf);			// R[hZbg(ŏ1̂)
		Endflag = myfile.eof();
		while(1){
			int result = ConfigObj.IoObj.read_Word(&tmp, Endflag);	// P̓ǂݍ
			if(result == READ_NEXT){				// P쐬̏ꍇ
				break;
			}else if(result == READ_SKIP){
				continue;
			}
			ConfigObj.ConfigGate();					// P𕪐
			if(result == READ_END){					// t@C̏I[܂ŏꍇ
				break;
			}
		}
	}

	ConfigObj.IoObj.FileEndCheck();						// t@CIɍs`FbN
	ConfigObj.BackupDefData(DefObj->GetVecData());
}

//--------------------------------------------------------------------------
// t@Cdo^Ȃ悤Ƀ`FbN
//--------------------------------------------------------------------------
void CheckDoubleRead(char *filename, char *passname)
{
extern	HTREEITEM AddTreeHyoji(char *);
extern	int  MyFunc_GetSrcBitType(char *);
	FileInfo tmpFile;


	if(passname == NULL){
		passname = "";
	}

	int SrcBit = MyFunc_GetSrcBitType(filename);
	if( ! SrcBit ){								// \[XłȂ
		return ;							// Ȃ
	}
	// C,C++,JavaVB,Delphin͓ɏłȂ߃G[Ƃ
	if( Fdata.LangBit ){
		if(Fdata.LangBit & (SRC_KIND_VB|SRC_KIND_DELPHI)){
			if((SrcBit & (SRC_KIND_VB|SRC_KIND_DELPHI)) == 0){
				Fdata.ErrFlg = 1;
				return;
			}
		}else{
			if(SrcBit & (SRC_KIND_VB|SRC_KIND_DELPHI)){
				Fdata.ErrFlg = 1;
				return;
			}
		}
	}


	int max = (int)Fdata.vecFileData.size()-1;				// zɕϊ
	int min = 0;
	int half= 0;

	if( Fdata.vecFileData.size() ){
		while(1){
			half = (min+max)/2;					// ̒n_
			if(Fdata.vecFileData[half].strSrcFName.length() == 0){
				cerr << "t@Co^̂߂̌ɂĈُ킪܂(װ)" << endl;
				break;
			}
			int result = strcmp(filename, Fdata.vecFileData[half].strSrcFName.c_str());
			if( result == 0 ){
				char *PassNameX = (char *)Fdata.vecFileData[half].strPathOnly.c_str();
				if(strcmp(PassNameX, passname) == 0){
					return;
				}
				break;
			}else if( max > min ){
				if( result > 0 ){
					min = half+1;
				}else{
					if(min == half){
						break;
					}else{
						max = half-1;
					}
				}
			}else{							// max == min ɂȂ
				if( result > 0 ){
					half++;
				}
				break;
			}
		}
	}

	tmpFile.strSrcFName = filename;
	tmpFile.strPathOnly = passname;
	tmpFile.SrcBit = SrcBit;
	tmpFile.tmp = 0;
#if !defined(DOS_VER)
	tmpFile.hItem = AddTreeHyoji(filename);
#endif
	memset(&tmpFile.Step, '\0', sizeof(tmpFile.Step));

	if((int)Fdata.vecFileData.size() > half){
		Fdata.vecFileData.insert(Fdata.vecFileData.begin()+half, tmpFile);
	}else{
		Fdata.vecFileData.push_back(tmpFile);
	}

	Fdata.LangBit |= SrcBit;
}


//--------------------------------------------------------------------------
// \[X̎ނrbgɕϊ
//--------------------------------------------------------------------------
int MyFunc_SrcLangToBit(int lang)
{
	int LangBit = 0;

	switch(lang){
	case SRC_KIND_C:
		LangBit = MASK_BIT_C;
		break;
	case SRC_KIND_CPP:
		LangBit = MASK_BIT_C|MASK_BIT_CPP;
		break;
	case SRC_KIND_JAVA:
		LangBit = MASK_BIT_JAVA;
		break;
	case SRC_KIND_VB:
		LangBit = MASK_BIT_VB;
		break;
	case SRC_KIND_DELPHI:
		LangBit = MASK_BIT_DELPHI;
		break;
	default:
		break;
	}

	return LangBit;
}


//--------------------------------------------------------------------------
// \[Xt@C`FbN
//--------------------------------------------------------------------------
int MyFunc_GetSrcKind(char *filename)
{
extern	Option	EpOp;

	char *pp = strrchr(filename, '.');			// Ō̃sIh܂ňړ

	if( pp ){						// AhX݂
		pp++;						// \L̎̕Ɉړ
		for(int cc=0;cc<(int)EpOp.vecExtension.size();cc++){
			char *ck_p = (char *)EpOp.vecExtension[cc].strName.c_str();
			if( ! stricmp(pp, ck_p) ){		// gqv
				return EpOp.vecExtension[cc].SrcKind;
			}
		}
	}

	return 0;
}

//--------------------------------------------------------------------------
// \[Xt@C̎ނ擾
//--------------------------------------------------------------------------
int MyFunc_GetSrcBitType(char *filename)
{
	char *pp = strrchr(filename, '.');			// Ō̃sIh܂ňړ

	if( pp ){						// AhX݂
		pp++;						// .L̎̕Ɉړ
		for(int cc=0;cc<(int)EpOp.vecExtension.size();cc++){
			char *ck_p = (char *)EpOp.vecExtension[cc].strName.c_str();
			if( ! stricmp(pp, ck_p) ){		// gqv
				return MyFunc_SrcLangToBit(EpOp.vecExtension[cc].SrcKind);
			}
		}
	}
	return 0;

}

//--------------------------------------------------------------------------
// IuWFNg֐Ƃđ`FbN֐
//--------------------------------------------------------------------------
bool NameRegistCheck(char *SetName)
{
extern	int MyFunc_isdigit(char);


	if(SetName == NULL || *SetName == '\0'){
		return false;
	}

	if( SeparateChar(*SetName) ){						// ؂蕶̏ꍇ
		return false;
	}

	if( ConfigObj.RsvObj.Search(SetName) )					// \̏ꍇ
		return false;

	if( MyFunc_isdigit(*SetName) )						// "123Func()"Ƃ֐͓o^łȂ
		return false;

	if( TypeObj->Search(SetName) ){						// ^̏ꍇ "uchar (*MyFunc)()"
		return false;
	}

	return true;
}

//--------------------------------------------------------------------------
// OԖtԂ
//--------------------------------------------------------------------------
std::string NamaeNameAdd(char *pStr)
{
	std::string strSpaceName;

	if( NamaeObj->GetNestCnt() ){						// l[Xy[X`Ȃ
		strSpaceName  = NamaeObj->GetNest();
		strSpaceName += "::";
	}

	strSpaceName += pStr;

	return strSpaceName;
}

