#include	<iostream>
#include	<string>
using namespace std;
#include	"EpMathDLL.h"

int	Enzanshi_Level(char *);
int	Enzanshi_Level_VB(char *moji);
char	*GetComand_C(char *, char *, int *, int);
char	*GetComand_B(char *, char *, int *, int);
int	CheckMathFunc_C(char *FuncName);
int	CheckMathFunc_B(char *FuncName);


//--------------------------------------------------------------------------
// ̉Zq𐔒l
//--------------------------------------------------------------------------
char *GetComand(char *first_str, char *str_p, int *set_com, int Ichi, int type)
{
	switch(type){
	case 0:
		return GetComand_C(first_str, str_p, set_com, Ichi);
	case 1:
		return GetComand_B(first_str, str_p, set_com, Ichi);
	default:
		break;
	}
	return NULL;
}

//--------------------------------------------------------------------------
// ̉Zq𐔒l
//--------------------------------------------------------------------------
char *GetComand_C(char *first_str, char *str_p, int *set_com, int Ichi)
{
	int  cnt;
	char *StartP = str_p;
	char Buf[10];

	memset(Buf, '\0', sizeof(Buf));
	Buf[0] = *first_str;
	*set_com = 0;

	if(*first_str == '('){
		*set_com = LEVEL_KAKKO_B;
		return StartP;
	}else if(*first_str == ')'){
		*set_com = LEVEL_KAKKO_A;
		return StartP;
	}

	for(cnt = 0;cnt<2;cnt++){
		if( ! SeparateChar(*str_p) ){
			break;
		}

		if(*str_p == '('){
			break;
		}else if(*str_p == ')'){
			break;
		}else{
			Buf[cnt+1] = *str_p;
			int ret = Enzanshi_Level(Buf);
			if(ret){
				// "++""--"̏ꍇ͎ɉZqȂΔF߂Ȃ
				if(Ichi != 0 && (ret == LEVEL_PULAS2 || ret == LEVEL_MINUS2)){
					char *pp = str_p+1;
					if( *pp != '\0' && ! SeparateChar(*pp) ){
						break;
					}
				}
				*set_com = ret;
				StartP++;
			}else{
				break;
			}
		}
		str_p++;
	}
	if( ! cnt ){
		*set_com = Enzanshi_Level(first_str);
	}

	return StartP;
}


//--------------------------------------------------------------------------
// Zq̗D揇ʂԂ
// Ԃl̒ႢD揇ʂB
//--------------------------------------------------------------------------
int Enzanshi_Level(char *moji)
{
	int rength = strlen(moji);

	if(rength==1){
		switch(*moji){
		case '!':
			return LEVEL_NOT;
		case '~':
			return LEVEL_MATIRUDA;
		case '*':
			return LEVEL_ASTA;
		case '/':
			return LEVEL_THRA;
		case '%':
			return LEVEL_PAR;
		case '+':
			return LEVEL_PULAS;
		case '-':
			return LEVEL_MINUS;
		case '<':
			return LEVEL_UP;
		case '>':
			return LEVEL_DOWN;
		case '&':
			return LEVEL_BIT_AND;
		case '^':
			return LEVEL_BIT_XOR;
		case '|':
			return LEVEL_BIT_OR;
		case '?':
			return LEVEL_HATENA;
		case ':':
			return LEVEL_KORON;
		case ',':
			return LEVEL_KANMA;
		default:
			break;
		}
	}else{
		if( !strcmp("++",moji) ){
			return LEVEL_PULAS2;
		}else if( !strcmp("--", moji) ){
			return LEVEL_MINUS2;
		}else if( !strcmp("<<", moji) ){
			return LEVEL_SHIFT_UP;
		}else if( !strcmp(">>", moji) ){
			return LEVEL_SHIFT_DOWN;
		}else if( !strcmp("<=", moji) ){
			return LEVEL_UP_ICOAL;
		}else if( !strcmp(">=", moji) ){
			return LEVEL_DOWN_ICOAL;
		}else if( !strcmp("==", moji) ){
			return LEVEL_ICOAL;
		}else if( !strcmp("!=", moji) ){
			return LEVEL_NOT_ICOAL;
		}else if( !strcmp("&&", moji) ){
			return LEVEL_AND;
		}else if( !strcmp("||", moji) ){
			return LEVEL_OR;
		}else if( !strcmp("+=", moji) ){
			return LEVEL_PULAS_IN;
		}else if( !strcmp("-=", moji) ){
			return LEVEL_MINUS_IN;
		}else if( !strcmp("*=", moji) ){
			return LEVEL_ASTA_IN;
		}else if( !strcmp("/=", moji) ){
			return LEVEL_THRA_IN;
		}else if( !strcmp("%=", moji) ){
			return LEVEL_PAR_IN;
		}else if( !strcmp(">>=",moji) ){
			return LEVEL_DOWN_IN;
		}else if( !strcmp("<<=",moji) ){
			return LEVEL_UP_IN;
		}else if( !strcmp("&=", moji) ){
			return LEVEL_ADN_IN;
		}else if( !strcmp("^=", moji) ){
			return LEVEL_XOR_IN;
		}else if( !strcmp("|=", moji) ){
			return LEVEL_OR_IN;
		}
	}

	return LEVEL_NON;
}

//--------------------------------------------------------------------------
// ̉Zq𐔒l
//--------------------------------------------------------------------------
char *GetComand_B(char *first_str, char *str_p, int *set_com, int Ichi)
{
	int  cnt;
	char *StartP = str_p;
	char Buf[10];

	memset(Buf, '\0', sizeof(Buf));
	Buf[0] = *first_str;
	*set_com = 0;

	if(*first_str == '('){
		*set_com = LEVEL_VB_KAKKO_B;
		return StartP;
	}else if(*first_str == ')'){
		*set_com = LEVEL_VB_KAKKO_A;
		return StartP;
	}

	for(cnt = 0;cnt<2;cnt++){
		if( ! SeparateChar(*str_p) ){
			break;
		}

		if(*str_p == '('){
			break;
		}else if(*str_p == ')'){
			break;
		}else{
			Buf[cnt+1] = *str_p;
			int ret = Enzanshi_Level_VB(Buf);
			if(ret){
				*set_com = ret;
				StartP++;
			}else{
				break;
			}
		}
		str_p++;
	}
	if( ! cnt ){
		*set_com = Enzanshi_Level_VB(first_str);
	}

	return StartP;
}


//--------------------------------------------------------------------------
// Zq̗D揇ʂԂ
// Ԃl̒ႢD揇ʂB
//--------------------------------------------------------------------------
int Enzanshi_Level_VB(char *moji)
{
	int rength = strlen(moji);

	if(rength==1){
		switch(*moji){
		case '^':
			return LEVEL_VB_JYOU;			// ^ (搔)
		case '*':
			return LEVEL_VB_ASTA;			// *
		case '/':
			return LEVEL_VB_THRA;			// /
		case '\\':
			return LEVEL_VB_SHOW;			// \ ()
		case '+':
			return LEVEL_VB_PULAS;			// +
		case '-':
			return LEVEL_VB_MINUS;			// -
		case '=':
			return LEVEL_VB_ICOAL;			// =
		case '<':
			return LEVEL_VB_UP;			// <
		case '>':
			return LEVEL_VB_DOWN;			// >
		case '!':
			return LEVEL_VB_NOT;			// ! (Not)
		default:
			break;
		}
	}else{
		if( !strcmp("<>",moji) ){
			return LEVEL_VB_NOT_ICOAL;
		}else if( !strcmp("<=", moji) ){
			return LEVEL_VB_UP_ICOAL;
		}else if( !strcmp(">=", moji) ){
			LEVEL_VB_DOWN_ICOAL;
		}
	}

	return LEVEL_NON;
}

//--------------------------------------------------------------------------
// Cu֐`FbN
// 0:֐ł͂Ȃ ̑:Cu֐̎ʎq
//--------------------------------------------------------------------------
int CheckMathFunc(char *FuncName, int type)
{
	switch(type){
	case 0:
		return CheckMathFunc_C(FuncName);
	case 1:
		return CheckMathFunc_B(FuncName);
	default:
		break;
	}
	return 0;
}

//--------------------------------------------------------------------------
// Cu֐`FbN
// 0:֐ł͂Ȃ ̑:Cu֐̎ʎq
//--------------------------------------------------------------------------
int CheckMathFunc_C(char *FuncName)
{
	if( ! strcmp(FuncName, "acos") ){
		return LEVEL_ACOS;			// acos() 
	}else if( ! strcmp(FuncName, "asin") ){
		return LEVEL_ASIN;			// asin() 
	}else if( ! strcmp(FuncName, "atan") ){
		return LEVEL_ATAN;			// atan() 
	}else if( ! strcmp(FuncName, "atan2") ){
		return LEVEL_ATAN2;			// atan2(,) 
	}else if( ! strcmp(FuncName, "cos") ){
		return LEVEL_COS;			// cos() 
	}else if( ! strcmp(FuncName, "sin") ){
		return LEVEL_SIN;			// sin() 
	}else if( ! strcmp(FuncName, "tan") ){
		return LEVEL_TAN;			// tan() 
	}else if( ! strcmp(FuncName, "cosh") ){
		return LEVEL_COSH;			// cosh() 
	}else if( ! strcmp(FuncName, "sinh") ){
		return LEVEL_SINH;			// sinh() 
	}else if( ! strcmp(FuncName, "tanh") ){
		return LEVEL_TANH;			// tanh() 
	}else if( ! strcmp(FuncName, "exp") ){
		return LEVEL_EXP;			// exp() 
//	}else if( ! strcmp(FuncName, "frexp") ){
//		return LEVEL_FREXP;			// frexp() 
	}else if( ! strcmp(FuncName, "ldexp") ){
		return LEVEL_LDEXP;			// ldexp(,)
	}else if( ! strcmp(FuncName, "abs") ){
		return LEVEL_ABS;			// abs() 
	}else if( ! strcmp(FuncName, "labs") ){
		return LEVEL_LABS;			// labs() 
	}else if( ! strcmp(FuncName, "log") ){
		return LEVEL_LOG;			// log() 
	}else if( ! strcmp(FuncName, "log10") ){
		return LEVEL_LOG10;			// log10() 
//	}else if( ! strcmp(FuncName, "modf") ){
//		return LEVEL_MODF;			// modf(,)
	}else if( ! strcmp(FuncName, "pow") ){
		return LEVEL_POW;			// pow(,)
	}else if( ! strcmp(FuncName, "sqrt") ){
		return LEVEL_SQRT;			// sqrt()
	}else if( ! strcmp(FuncName, "ceil") ){
		return LEVEL_CEIL;			// ceil()
	}else if( ! strcmp(FuncName, "floor") ){
		return LEVEL_FLOOR;			// floor()
	}else if( ! strcmp(FuncName, "fmod") ){
		return LEVEL_FMOD;			// fmod(,)
	}

	return 0;
}

//--------------------------------------------------------------------------
// Cu֐`FbN
// 0:֐ł͂Ȃ ̑:Cu֐̎ʎq
//--------------------------------------------------------------------------
int CheckMathFunc_B(char *FuncName)
{
	if( ! stricmp(FuncName, "Mod") ){		// Mod (܂)
		return LEVEL_VB_REST;
	}else if( ! stricmp(FuncName, "And") ){		// && (And)
		return LEVEL_VB_AND;
	}else if( ! stricmp(FuncName, "Or") ){		// || (Or)
		return LEVEL_VB_OR;
	}else if( ! stricmp(FuncName, "Xor") ){		// ^ (Xor)
		return LEVEL_VB_XOR;
	}else if( ! stricmp(FuncName, "Eqv") ){		// (Eqv)
		return LEVEL_VB_EQV;
	}else if( ! stricmp(FuncName, "Imp") ){		// (Imp)
		return LEVEL_VB_IMP;
	//-----------------------------------------------------
	}else if( ! stricmp(FuncName, "abs") ){		// abs() Βl߂
		return LEVEL_VB_ABS;
	}else if( ! stricmp(FuncName, "atn") ){		// atn()
		return LEVEL_VB_ATN;
	}else if( ! stricmp(FuncName, "cos") ){		// cos()
		return LEVEL_VB_COS;
	}else if( ! stricmp(FuncName, "exp") ){		// exp()
		return LEVEL_VB_EXP;
	}else if( ! stricmp(FuncName, "fix") ){		// fix() Ԃ
		return LEVLE_VB_FIX;
	}else if( ! stricmp(FuncName, "int") ){		// int() Ԃ -8.8  -9
		return LEVEL_VB_INT;
	}else if( ! stricmp(FuncName, "log") ){		// log()
		return LEVEL_VB_LOG;
	}else if( ! stricmp(FuncName, "sin") ){		// sin()
		return LEVEL_VB_SIN;
	}else if( ! stricmp(FuncName, "sqr") ){		// sqr() ߂
		return LEVEL_VB_SQR;
	}else if( ! stricmp(FuncName, "tan") ){		// tan()
		return LEVEL_VB_TAN;
	}
	return 0;
}




