//=============================================================================
// \ێ邽߂̃NXB
//=============================================================================
#include	<windows.h>
#include	<commctrl.h>
#include	<iostream>
#include	<fstream>
#include	<vector>
using namespace std;
#include	"common.h"
#include	"SvFileStack.h"
#include	"SvRsvWord.h"


extern	SvFileStack	*FileStackObj;						// ݏ̃t@Ci[IuWFNg


//--------------------------------------------------------------------------
// `t@C݂ȂƂɎg`
// ꂽ\B
//--------------------------------------------------------------------------
char	*OrgReserveWord_C[] = {
	"auto",		"break",	"case",		"char",
	"const",	"continue",	"default",	"do",
	"double",	"else",		"enum",		"extern",
	"far",		"float",	"for",		"fortran",
	"goto",		"huge",		"if",		"int",
	"long",		"near",		"pascal",	"register",
	"return",	"short",	"sizeof",	"static",
	"struct",	"switch",	"typedef",	"union",
	"unsigned",	"void",		"while",
	"",
};
char	*OrgReserveWord_Cpp[] = {
	"catch",	"class",	"__declspec",	"delete",
	"dllexport",	"dllimport",	"friend",	"inline",
	"naked",	"new",		"operator",	"private",
	"protected",	"public",	"signed",	"template",
	"thread",	"this",		"throw",	"try",
	"virtual",	"volatile",	"xalloc",	"",
};
char	*OrgReserveWord_Delphi[] = {
	"and",		"array",	"as",		"asm",
	"begin",	"case",		"class",	"const",
	"constructor",	"destructor",	"dispinterface","div",
	"do",		"downto",	"else",		"end",
	"except",	"exports",	"file",		"finalization",
	"finally",	"for",		"function",	"goto",
	"if",		"implementation",		"in",
	"inherited",	"initialization","inline",	"interface",
	"is",		"label",	"library",	"mod",
	"nil",		"not",		"object",	"of",
	"or",		"out",		"packed",	"procedure",
	"program",	"property",	"raise",	"record",
	"repeat",	"resourcestring","set",		"shl",
	"shr",		"string",	"then",		"threadvar",
	"to",		"try",		"type",		"unit",
	"until",	"uses",		"var",		"while",
	"with",		"xor",
	"",
};
char	*OrgReserveWord_VB[] = {
	"Alias",	"And",		"Any",		"Append",
	"As",		"BeginTrans",	"Binary",	"ByVal",
	"Call",		"Case",		"Dim",		"Do",
	"DoEvents",	"Else",		"ElseIf",	"End",
	"EndIf",	"Exit",		"For",		"Function",
	"Global",	"GoSub",	"GoTo",		"If",
	"Integer",	"Is",		"Next",		"Not",
	"Nothing",	"Now",		"Null",		"ReDim",
	"Rem",		"Set",		"Sub",		"Then",
	"to",		"true",		"Until",	"Val",
	"Wend",		"While",
	"",
};



//--------------------------------------------------------------------------
// RXgN^
//--------------------------------------------------------------------------
SvRsvWord::SvRsvWord()
{
}

//--------------------------------------------------------------------------
// fXgN^
// spɂȂGAJ
//--------------------------------------------------------------------------
SvRsvWord::~SvRsvWord()
{
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
void SvRsvWord::Init()
{
	vecRsvWord.clear();
}

//--------------------------------------------------------------------------
// \ۑB
//--------------------------------------------------------------------------
void SvRsvWord::SetData(char *pStr, int Langu)
{
	int  SetPos=0;
	ReserveInfo tmpReserv;

	if( Search(pStr, Langu, &SetPos, 1) ){
		// ɗ\ꂪo^Ă
		vecRsvWord[SetPos].LangInfo |= Langu;		// gp̓o^
		return;
	}

	tmpReserv.strReserveName = pStr;
	tmpReserv.LangInfo = Langu;				// gp̓o^

	if((int)vecRsvWord.size() > SetPos){
		// rɒǉꍇ
		vecRsvWord.insert(vecRsvWord.begin()+SetPos, tmpReserv);
	}else{
		// ԍŌɒǉꍇ
		vecRsvWord.push_back(tmpReserv);
	}
}

//--------------------------------------------------------------------------
// \ꂩǂ̔
// \Ȃΐ^ԂB
//--------------------------------------------------------------------------
int SvRsvWord::Search(char *pStr)
{
	int dummy;
	return Search(pStr, 0, &dummy, 0);
}

//--------------------------------------------------------------------------
// \ꂩǂ̔
// \Ȃΐ^ԂB
//--------------------------------------------------------------------------
int SvRsvWord::Search(char *pStr, int Langu, int *SetPos, int SetMode)
{
	int max = (int)vecRsvWord.size()-1;			// zɕϊ
	int min = 0;
	int half= 0;
	int result;


	if(Langu == 0){
		Langu = FileStackObj->SrcLang();
	}

	if( vecRsvWord.size() ){
		while(1){
			half = (min+max)/2;			// ̒n_
			if(vecRsvWord[half].strReserveName.length() == 0){
				cerr << "\ꌟɂĈُ킪܂(װ)" << endl;
				break;
			}
			result = MyFunc_strcmp(pStr, vecRsvWord[half].strReserveName.c_str());
			if( result == 0 ){
				*SetPos = half;
				if( SetMode ){			// \̓o^sۂ̌Ȃ
					return 1;		// ɓo^
				}
				return (vecRsvWord[half].LangInfo & Langu);
			}else if( max > min ){
				if( result > 0 ){
					min = half+1;
				}else{
					if(min == half){
						break;
					}else{
						max = half-1;
					}
				}
			}else{					// max == min ɂȂ
				if( result > 0 ){
					half++;
				}
				break;
			}
		}
	}
	*SetPos = half;
	return 0;
}


//--------------------------------------------------------------------------
// Eptreeݒ.datt@C݂Ȃꍇ̏
//--------------------------------------------------------------------------
void SvRsvWord::FileNotExist()
{
	int a;
	for(a=0;;a++){
		if(*OrgReserveWord_C[a] == NULL)
			break;
		SetData(OrgReserveWord_C[a], MASK_BIT_C);
	}
	for(a=0;;a++){
		if(*OrgReserveWord_Cpp[a] == NULL)
			break;
		SetData(OrgReserveWord_Cpp[a], MASK_BIT_CPP);
	}
	for(a=0;;a++){
		if(*OrgReserveWord_VB[a] == NULL)
			break;
		SetData(OrgReserveWord_VB[a], MASK_BIT_VB);
	}
	for(a=0;;a++){
		if(*OrgReserveWord_Delphi[a] == NULL)
			break;
		SetData(OrgReserveWord_Delphi[a], MASK_BIT_DELPHI);
	}
}

//--------------------------------------------------------------------------
// \\邽߂̊֐B
//--------------------------------------------------------------------------
void SvRsvWord::Print()
{
	ofstream RsvStream;
	EpOutFileOpen("Ep\mF.txt", &RsvStream);

	RsvStream << "\o܂B" << endl;
	
	char *StrP;
	int a=0;
	for(a=0;a<(int)vecRsvWord.size();a++){
		char *pp = (char *)vecRsvWord[a].strReserveName.c_str();
		if( pp == NULL )
			break;
		RsvStream.setf(ios_base::right, ios_base::adjustfield);	// Elw
		RsvStream.width(3);
		RsvStream << a << ", ";

		switch(vecRsvWord[a].LangInfo){
		case MASK_BIT_C:
			StrP = "C";
			break;
		case MASK_BIT_CPP:
			StrP = "CPP";
			break;
		case MASK_BIT_JAVA:
			StrP = "JAVA";
			break;
		case (MASK_BIT_C|MASK_BIT_CPP):
			StrP = "C/CPP";
			break;
		case (MASK_BIT_C|MASK_BIT_JAVA):
			StrP = "C/JAVA";
			break;
		case (MASK_BIT_CPP|MASK_BIT_JAVA):
			StrP = "CPP/JAVA";
			break;
		case (MASK_BIT_C|MASK_BIT_CPP|MASK_BIT_JAVA):
			StrP = "C/CPP/JAVA";
			break;
		case MASK_BIT_VB:
			StrP = "VB";
			break;
		case MASK_BIT_DELPHI:
			StrP = "DELPHI";
			break;
		case MASK_BIT_VB|MASK_BIT_DELPHI:
			StrP = "VB/DELPHI";
			break;
		default:
			StrP = "";
			break;
		}

		RsvStream.setf(ios_base::left, ios_base::adjustfield);	// lw
		RsvStream.width(10);
		RsvStream << StrP << ", ";
		RsvStream << pp << ",";
		RsvStream << endl;
	}
	RsvStream << "ȏオ\łB`F" << a << "" << endl;

	RsvStream.close();
}


